<?php

/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
 
/**
 * @file Mysql.php
 * 
 * @author Matthieu
 * 
 * @version 0.1

 
@usage

$oSqlConnection = new Mysql();
$s_sqlSelect = "SELECT nbvisiteur FROM compteur_visite WHERE ip = '192.168.0.23'";
$o_sqlResult = $oSqlConnection->query($s_sqlSelect);
while ( $o_result = $oSqlConnection->getObject($o_sqlResult) )
{
	// caractéristiques des messages
	$n_nbVisiteur = $o_result->nbvisiteur;
}


Installation d'un environnement php, MySQL sous Windows (pour vos tests)
WampServer :  http://www.wampserver.com/
EasyPHP :  http://www.easyphp.org/


exemple de requetes MySQL
 
SELECT *
FROM wordpress_useronline
WHERE username = 'Matthieu'


SELECT ID, user_login
FROM wordpress_users
WHERE user_login = 'Matthieu' AND ID = 2


SELECT posts.post_author, users.user_login, posts.post_date, posts.post_content, posts.post_title, posts.post_name
FROM `wordpress_posts` posts
INNER JOIN  wordpress_users users ON users.ID = posts.post_author 
AND  users.user_login = 'Matthieu' 

*/
class Mysql 
{
	
	private $oLinkSql;// la connexion mysql en cours
	private $oResult;// le resultat de la requete executee

	private $aConnect;// la configuration de la base de donnees
	 
	// ---------------------------------- __construct() ----------------------------------------------------------
   /**
	* @brief 
	* @param -
	*/
	public function __construct()
	{
		// initialisation des propriétés de la classe
		$this->aConnect 	= array();
		
		/* paramètres de connexion à la base de donnés */
		$this->aConnect['ip']	= "localhost"; // le serveur
		$this->aConnect['login']	= "root"; // le login
		$this->aConnect['password']	= "mot_de_passe"; // mot de passe
		$this->aConnect['database']	= "nom_de_la_base"; // nom de la base de donnee
		$this->aConnect['port'] = "3306"; // 
		$this->aConnect['sgbd'] = "mysql"; // le type de base
		$this->aConnect['options'] = array(
					PDO::ATTR_ERRMODE 				=> PDO::ERRMODE_EXCEPTION,// Activation des exceptions PDO :		
					PDO::ATTR_DEFAULT_FETCH_MODE 	=> PDO::FETCH_OBJ,// Change le fetch mode par défaut sur FETCH_OBJ ( fetch() retournera un objet simple )
					PDO::MYSQL_ATTR_INIT_COMMAND    => "SET NAMES utf8" // mysql au format utf8 
				); // les options à activer par défaut
		
		$sDatabaseDns = $this->aConnect['sgbd'].":host=".$this->aConnect['ip'].";dbname=".$this->aConnect['database'];
		// adresse id  $_SERVER["REMOTE_ADDR"]; 

		// Connection au serveur
		try
		{
			$this->oLinkSql = new PDO( $sDatabaseDns, $this->aConnect['login'], $this->aConnect['password'], $this->aConnect['options'] );
		}
		catch ( Exception $oErreur )// erreur de connexion a la base -> redirection sur une page d'erreur
		{
			echo "Connection à MySQL impossible : ", $oErreur->getMessage();
			die();
			echo "<meta http-equiv=\"refresh\" content=\"0; URL=erreurs/erreurBDD.htm\">";// possibilité d'utiliser un  header('Location: erreurs/erreurBDD.htm');   
			exit;
		}


		
	 }
	
	
	
	// -----------------------------------------------------------------------------------------------------------
	// ------------------------------------------- PUBLIC FUNCTIONS  ---------------------------------------------
	// -----------------------------------------------------------------------------------------------------------
	


	/**
	 * Permet de recuperer les parametres de connexion de la base.
	 * Utile pour d'autre scripts php.
	 *
	 * @return : un tableau avec les parametres de connexion de la base
	 */
	public function getConfig()
	{
		return $this->aConnect;
	} 
	
	
	/**
	 * Execute une requete mysql
	 *
	 * @param requete
	 * @return : un message d'erreur ou l'objet avec le resultat de la requete
	 */
	public  function query($sSqlQuery)
	{ 
		if ( $this->oResult = @$this->oLinkSql->query($sSqlQuery) )
			return $this->oResult;
		else
			return 'Query : '.$sSqlQuery.' - error : '.@mysqli_error($this->oLinkSql);
	}	
	 
	 
	 
	/*
	 * Donne le resultat de la requete sous forme d'objet
	 *
	 * @param $oResultQuery : le resultat renvoye par une requete pour obtenir un objet
	 */
	public function getObject($oResultQuery = NULL)
	{
		// dans le resultat d'une autre requete
		if($oResultQuery != NULL)
			return $oResultQuery->fetch();
		
		// donne le resultat de la derniere requete executee
		if ($this->oResult != NULL)
			return $this->oResult->fetch();

		echo "Erreur, aucun résultat de requête à parcourir !!!";
		return;
	}

	
	
	// ---------------------------------- getNumRows() ----------------------------------------------------------
	/**
	* @brief donne le nombre d'elements modifies par la requete
	* Pratique dans le cas des INSERT
	* 
	* @return (integer) le nombre d'elements modifies par la requete
	*/
	public function getNumRows($oResultQuery = NULL)
	{
		// dans le resultat d'une autre requete
		if($oResultQuery != NULL)
			return $oResultQuery->rowCount();
		
		// donne le resultat de la derniere requete executee
		if ($this->oResult != NULL)
			return $this->oResult->rowCount();

		echo "Erreur, aucun élément modifié !!!";
		return;
	}
	
	
	// ---------------------------------- lastInsertId() ----------------------------------------------------------
	/**
	* @brief Retourne l'identifiant automatiquement généré par la dernière requête.
	* Pratique dans le cas d'un INSERT ou UPDATE pour recuperer le dernier identifiant
	* 
	* @return (integer) le dernier identifiant insere 
	*/
	public function lastInsertId($oResultQuery = NULL)
	{
		// dans le resultat d'une autre requete
		if($oResultQuery != NULL)
			return $oResultQuery->lastInsertId();
		
		// donne le resultat de la derniere requete executee
		if ($this->oResult != NULL)
			return $this->oResult->lastInsertId();

		echo "Erreur, aucun élément inséré !!!";
		return;
	}
	
	
	
	// -----------------------------------------------------------------------------------------------------------
	// ----------------------------------------- Others ----------------------------------------------------------
	// -----------------------------------------------------------------------------------------------------------


 	/**
	* @brief
	*
	* @return 
	*/
	public function __destruct() 
	{
 		$this->oLinkSql = NULL ;		
		$b_rep = @mysqli_close($this->oLinkSql);
		if( $b_rep != true )
			return 'Erreur closing sql connexion!';
 	}
	
	
	
	// ---------------------------------------- __toString() ----------------------------------------------------	
	/**
	 * @brief Returns the string representation of this instance.
	 * 
	 * @usage   echo(myObject) ou print(myObject)
	 * @return  the string representation of this instance.
	 */	
	public function __toString() 
	{
		$s_classContent = "[Object ".__CLASS__."]<br />";

		foreach($this as $prop => $value) 
		{
		 	$s_classContent .= "$prop => $value <br />";
		}
		 
		return $s_classContent;
   	}
	 
}
?>